SystemOrganization addCategory: #'XML-Parser-GTExtensions'!

!ZnStringEntity methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 5/8/2015 23:03'!
gtInspectorXmlIn: composite
	<gtInspectorPresentationOrder: 40>
	| xml |
	xml := [XMLDOMParser parse: self string]
		on: XMLParserException
		do: [ ^ self ].
	(xml gtInspectorTreeIn: composite)
		title: 'XML'! !

!XMLDocument class methodsFor: '*XML-Parser-GTExtensions' stamp: 'StefanReichhart 3/26/2015 18:27'!
gtExampleXmlNode
	<gtExample>
	^ XMLDOMParser parse: '<document><a></a><b></b></document>'! !

!XMLNodeWithElements class methodsFor: '*XML-Parser-GTExtensions' stamp: 'StefanReichhart 3/26/2015 18:28'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode nodes! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 7/16/2014 17:21'!
gtDisplayOn: stream
	stream nextPutAll: self name! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 1/31/2014 07:22'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 40>
	composite text 
		title: 'Source';
		format: [ self prettyPrinted ]! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 2/23/2015 22:29'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite tree 
		title: 'Tree';
		display: [ { self } ];
		children: #elements;
		format: #gtDisplayString;
		when: [self hasElements];
		rootsExpanded! !

!XMLNodeWithElements methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 3/6/2015 14:40'!
gtName
	^ ''! !

!XMLElement class methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 5/8/2015 23:04'!
gtExampleXmlNode
	<gtExample>
	^ XMLDocument gtExampleXmlNode firstElement! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 16:48'!
formForImageEntity: imageEntity
  | imageType parserClassName parserClass parser |
  imageType := imageEntity contentType sub.
  parserClassName := imageType asUppercase, #ReadWriter.
  parserClass := Smalltalk globals at: parserClassName asSymbol.
  parser := parserClass on: imageEntity readStream.
    ^ parser nextImage! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'monty 4/27/2015 11:37'!
gtDisplayOn: stream
	stream
		nextPut: $<;
		nextPutAll: self name.
	self hasAttributes
		ifTrue: [ 
			self
				attributeNodesDo: [ :each | 
					stream space.
					each gtDisplayOn: stream ] ].
	stream nextPut: $>! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'AndreiChis 7/12/2014 20:14'!
gtInspectorImageIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 40>
	|client url|
	
	(aGTInspector panes size > 1) 
		ifFalse: [ ^ self ].	
	
	client := (aGTInspector panes reversed collect: [ :each | (each port: #entity) value ])
		detect: [ :each | 
			(each isKindOf: ZnClient)
				and: [each request notNil]]
		ifNone: [ ^ self ].
	url := client request absoluteUrl.
	
	^ composite morph 
		title: 'Image';
		display: [ 
			self formForImageEntity:
				(ZnClient new 
      				beOneShot;
      				get: url/ (self attributeNodes attributeValueAt: 'src');
      				entity)];
		when: [ self name = 'img' and: [(self attributeNodes attributeValueAt: 'src') notNil]]! !

!XMLElement methodsFor: '*XML-Parser-GTExtensions' stamp: 'TudorGirba 3/6/2015 14:40'!
gtName
	^ self localName! !
